/*
 * Alterando o tamanho do segmento de dados
 */ 
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


char str_dados[10];

int main() {
  char str_pilha[10], *topo;
  int pagesize = getpagesize();

  printf("Tamanho em bytes de um endereço: %d\n", sizeof(char*));
  printf("Tamanho em bytes de uma página: %d\n", pagesize);
  
  printf("str_pilha  = %p\n", (void*) str_pilha);
  printf("main       = %p\n", (void*) main);  
  printf("str_dados =  %p\n", (void*) str_dados);

  topo = sbrk(0);
  printf("Topo da área de dados = %p\n", topo);

  if (sbrk(pagesize) == -1)
    printf("Não foi possível alterar o segmento de dados\n");

  topo = sbrk(0);
  printf("Topo da área de dados = %p\n", topo);
  
  return 0;
}
