/*
 * Uma thread pode sobrescrever a pilha de outra thread?
 * 
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define N_THR 10

int* end_pilha[N_THR];

void rec(int thr_id) {
  int v[4096];
  if (&thr_id > end_pilha[thr_id-1])
    rec(thr_id);
}

void* f_thread(void *v) {
  int thr_id = (int) v;
  printf("Início da Thread %d.\n", thr_id);  
  end_pilha[thr_id] = &thr_id;
  if (thr_id == 5) {
    sleep(1);
    rec(thr_id);
  }
  else
    sleep(10);
  printf("Final da Thread %d.\n", thr_id);  

  return NULL; 
} 

int main() {
  pthread_t thr[N_THR];
  int i;
  
  for (i = 0; i < N_THR; i++) 
    pthread_create(&thr[i], NULL, f_thread, (void*) i);

  for (i = 0; i < N_THR; i++) 
    pthread_join(thr[i], NULL); 

  return 0;
}
